unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ECCrypt, ExtCtrls;

type
  TfrmEllipticCurveTest = class(TForm)
    lblPublicKey: TLabel;
    edtSecret: TEdit;
    lblExchValue: TLabel;
    lblSessionKey: TLabel;
    lblDecSessKey: TLabel;
    btnMakeKey: TButton;
    edtPublicKey1: TEdit;
    btnEncrypt: TButton;
    edtExchValue1: TEdit;
    edtSessionKey1: TEdit;
    edtDecSessionKey1: TEdit;
    btnDecrypt: TButton;
    btnSign: TButton;
    edtSignature: TEdit;
    btnVerify: TButton;
    edtSig: TEdit;
    EllipticCurve1: TEllipticCurve;
    lblSecret: TLabel;
    lblSigValid: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    lblSig2: TLabel;
    procedure btnMakeKeyClick(Sender: TObject);
    procedure btnEncryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
    procedure btnSignClick(Sender: TObject);
    procedure btnVerifyClick(Sender: TObject);
  private
    { Private declarations }
  end;

var
  frmEllipticCurveTest: TfrmEllipticCurveTest;

implementation

{$R *.DFM}

var
  Digest: TDigest;

procedure TfrmEllipticCurveTest.btnMakeKeyClick(Sender: TObject);
begin
     EllipticCurve1.PassPhrase := edtSecret.Text;
     EllipticCurve1.MakeKey;
     edtPublicKey1.Text := EllipticCurve1.KeyPublic;
end;

procedure TfrmEllipticCurveTest.btnEncryptClick(Sender: TObject);
begin
     EllipticCurve1.Encrypt;
     edtExchValue1.text := EllipticCurve1.ExchangedValue;
     edtSessionKey1.text := EllipticCurve1.KeySession;
end;

procedure TfrmEllipticCurveTest.btnDecryptClick(Sender: TObject);
begin
     EllipticCurve1.KeySession := '';
     EllipticCurve1.Decrypt;
     edtDecSessionKey1.text := EllipticCurve1.KeySession;
end;

procedure TfrmEllipticCurveTest.btnSignClick(Sender: TObject);
var
     i: integer;
begin
     Randomize;
     for i := 0 to 19 do
     begin
          Digest[i] := Random(256);
     end;
     EllipticCurve1.Sign(Digest);
     edtSignature.Text := EllipticCurve1.Signature;
end;

procedure TfrmEllipticCurveTest.btnVerifyClick(Sender: TObject);
begin
     EllipticCurve1.Signature := edtSignature.Text;
     EllipticCurve1.Verify(Digest);

     If EllipticCurve1.Valid then
     begin
          edtSig.Text := 'Valid';
     end
     else
     begin
          edtSig.Text := 'Not Valid';
     end;
end;


end.

